Index: branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/PurchaseOrderEntry/FrmPurchaseOrderEntryAuxiliary.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/PurchaseOrderEntry/FrmPurchaseOrderEntryAuxiliary.cs	(revision 50)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/PurchaseOrderEntry/FrmPurchaseOrderEntryAuxiliary.cs	(revision 51)
@@ -126,6 +126,104 @@
         }
         #endregion
 
+        #region 直接表示時の対象リストを作成する
+        /// <summary>
+        /// 直接表示時の対象リストを作成する
+        /// </summary>
+        private void SetOrderEntryList()
+        {
+            IOProcessApprovalDetail AppDetailDB = new IOProcessApprovalDetail();
+            try
+            {
+
+                //ConstructionCode = 0,
+                //FirstString,
+                //SecondString,
+                //CompanyCode,
+                //CompanyName,
+                //ExecutionAmount,
+                //SourceCode,
+                //PurchaseOrderflg,
+                //DetailString,
+                //ApprovalStatus,
+                //PurchaseSeqNo,
+                //LedgerLine,
+                //OrderNo,
+                //PrintoutDate,
+
+                m_DetailList.Clear();
+                // 一覧リストを作成する
+                string strSQL = AppDetailDB.CreatePrimarykeyString(m_ConstructionCode, (int)ClsExcute.ApprovalListNo.PurchaseOrderEntryApproval, m_OrderNo);
+                strSQL += " ORDER BY ORDERNO";
+                List<ProcessApprovalDetail> DetailList = new List<ProcessApprovalDetail>();
+                if (!AppDetailDB.SelectAction(strSQL, ref DetailList)) return;
+
+                foreach (ProcessApprovalDetail CurRec in DetailList)
+                {
+                    m_DetailList.Add(new object[] { m_ConstructionCode,
+                                                    "",
+                                                    "",
+                                                    0,
+                                                    "",
+                                                    0,
+                                                    m_ConstructionCode,
+                                                    1,
+                                                    "",
+                                                    (int)CommonDefine.ApprovalStatus.Approval,
+                                                    CurRec.LinkCode,
+                                                    0,
+                                                    m_OrderNo,
+                                                    DateTime.Now });
+                }
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                AppDetailDB.close(); AppDetailDB = null;
+            }
+        }
+        #endregion
+
+        #region 注文書明細選択画面表示
+        /// <summary>
+        /// 注文書明細選択画面表示
+        /// </summary>
+        private bool DispOrderEntryList()
+        {
+            FrmOrderEntryList frm = new FrmOrderEntryList();
+            try
+            {
+                frm.OrderFrm = this;
+                this.Hide();
+                frm.ConstructionCode = m_ConstructionCode;
+                frm.ShowDialog();
+
+                // 終了選択時
+                if (frm.ComplateFlg == DialogResult.Cancel) return false;
+
+                object[] objRec = (object[])m_DetailList[0];
+                m_OrderNo = CommonMotions.cnvInt(objRec[(int)FrmOrderEntryList.ReadDBColumn.OrderNo]);
+                if (m_OrderNo == 0) m_OrderNo = -1;
+
+                this.Show();
+
+                return true;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                frm.Dispose(); frm = null;
+            }
+        }
+        #endregion
+
         #region 初期データ表示
         /// <summary>
         /// 初期データ表示
@@ -134,15 +232,53 @@
         {
             try
             {
+                // ----- データ表示
                 // ヘッダー情報表示
                 DispHeader();
 
-                // 注文書データを読み込む
+                // 注文書よりデータを取り込む
                 if (!SetPurchaseOrderData())
                 {
-                    // 無い場合は工事予算書よりデータを取り込む
+                    // 工事詳細台帳よりデータを取り込む
                     CreateNewOrderData();
+
+                    // 承認データ受付番号セット
+                    SetApprovalOrderNo();
                 }
+
+                // 申請・承認表示処理
+                InitApprovalDisplay();
+
+                // 参照時は変更できない
+                if (m_EditLock)
+                {
+                    DisplayReadOnly();
+                    btnApproval.Enabled = false;
+                    btnPetition.Enabled = false;
+                }
+
+                // *-----* 処理移動ボタン設定 *-----*
+                CreateProcessContextMenu(m_SubForm);
+                // *-----* 処理移動ボタン設定 *-----*
+
+                // 承認画面の「承認対象データを見る」からの起動時は承認ボタンの表示がある
+                bool bApproval = ClsApprovalPermission.ExceApprovalScreen();
+                if (bApproval)
+                {
+                    // 工事案件の管理部署を取得する
+                    int DepartmentCode = ClsApprovalPermission.GetFromConstructionTheDepartment(m_ConstructionCode);
+                    // 承認対象コードを取得する
+                    int ApprovalCode = ClsExcute.AppovalList.First(x => x.Value.Equals("注文書承認")).Key;
+                    // 案件に対して申請がされているかを確認する
+                    bool Pettition = ClsApprovalPermission.CheckPetition(m_ConstructionCode, ApprovalCode, m_OrderNo);
+                    // ログイン者が承認者かを確認する
+                    bool Approvaler = ClsApprovalPermission.CheckUserForApprover(ApprovalCode, DepartmentCode);
+                    // 申請中でログイン者が承認者の場合は承認ボタンを表示する
+                    if (Pettition && Approvaler)
+                    {
+                        pnlApprovalButton.Visible = true;
+                    }
+                }
             }
             catch (System.Exception ex)
             {
@@ -253,6 +389,301 @@
         }
         #endregion
 
+        #region 承認データ受付番号セット
+        /// <summary>
+        /// 承認データ受付番号セット
+        /// </summary>
+        private void SetApprovalOrderNo()
+        {
+            IOProcessApproval ProAppDB = new IOProcessApproval();
+            try
+            {
+                // 受付番号を取得する
+                object[] objrec = (object[])m_DetailList[0];
+                m_OrderNo = CommonMotions.cnvInt(objrec[(int)FrmOrderEntryList.ReadDBColumn.OrderNo]);
+
+                // オーダー番号作成
+                if (m_OrderNo == 0)
+                {
+                    m_OrderNo = ProAppDB.SelectMaxOrderNoCount(ProAppDB.CreatePrimarykeyString(m_ConstructionCode,
+                                                            (int)ClsExcute.ApprovalListNo.PurchaseOrderEntryApproval));
+                    m_OrderNo++;
+                }
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                ProAppDB.close(); ProAppDB = null;
+            }
+        }
+        #endregion
+
+        // ---------- 工事詳細台帳よりデータ作成　　　　↓↓
+        #region 工事詳細台帳より読み込むSQLを作成する
+        /// <summary>
+        /// 工事詳細台帳より読み込むSQLを作成する
+        /// </summary>
+        /// <param name="strSQL"></param>
+        private void CreateNewDataSQL(ref string strSQL)
+        {
+            try
+            {
+                // 工事台帳コードのセット
+                object[] ParentRec = (object[])m_DetailList[0];
+                strSQL = string.Format(" WHERE CONSTRUCTIONCODE = {0}",
+                                        CommonMotions.cnvInt(ParentRec[(int)FrmOrderEntryList.ReadDBColumn.ConstructionCode]));
+
+                int SourceCode = 0;
+                int CompanyCode = 0;
+                int brkSourceCode = 0;
+                bool bFirstCode = true;
+                bool bFirstCompany = true;
+                foreach (object[] CurRec in m_DetailList)
+                {
+                    SourceCode = CommonMotions.cnvInt(CurRec[(int)FrmOrderEntryList.ReadDBColumn.SourceCode]);
+                    CompanyCode = CommonMotions.cnvInt(CurRec[(int)FrmOrderEntryList.ReadDBColumn.CompanyCode]);
+                    // 工事番号のセット
+                    if (brkSourceCode != SourceCode)
+                    {
+                        if (bFirstCode)
+                        {
+                            strSQL += " AND";
+                            bFirstCode = false;
+                        }
+                        else
+                        {
+                            strSQL += ")) OR";
+                        }
+
+                        strSQL += string.Format(" (SOURCECODE = {0} AND (", SourceCode);
+
+                        brkSourceCode = SourceCode;
+                        bFirstCompany = true;
+                    }
+                    // 会社番号のセット
+                    if (!bFirstCompany) strSQL += " OR";
+
+                    strSQL += string.Format(" COMPANYCODE = {0}", CompanyCode);
+                    
+                    bFirstCompany = false;
+                }
+                strSQL += ")) ORDER BY COMPANYCODE";
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 工事詳細台帳よりデータを取り込む
+        /// <summary>
+        /// 工事詳細台帳よりデータを取り込む
+        /// </summary>
+        /// <returns></returns>
+        private bool CreateNewOrderData()
+        {
+            //IOConstructionBudgetDetail DetailDB = new IOConstructionBudgetDetail();
+            IOConstructionLedgerDetail DetailDB = new IOConstructionLedgerDetail();
+            IOPurchaseOrder OrderDB = new IOPurchaseOrder();
+            try
+            {
+                //if (m_DetailList.Count == 0) return false;
+
+                // 対象データSQL作成
+                string strSQL = string.Empty;
+                CreateNewDataSQL(ref strSQL);
+                // 工事詳細台帳データ読込
+                //List<ConstructionBudgetDetail> DetailList = new List<ConstructionBudgetDetail>();
+                List<ConstructionLedgerDetail> DetailList = new List<ConstructionLedgerDetail>();
+                if (!DetailDB.SelectAction(strSQL, ref DetailList)) return false;
+                if (DetailList.Count == 0) return false;
+
+                // デフォルトページを削除する
+                this.TabCollections.TabPages.RemoveAt(0);
+
+                int icnt = OrderDB.SelectMaxSeqNoCount(OrderDB.CreatePrimarykeyString(m_ConstructionCode));
+                int PageSeqNo = icnt;
+                bool binit = true;
+                int Break_CompanyCode = 0;
+                double Break_Total = 0;
+                //List<ConstructionBudgetDetail> SumBuffer = new List<ConstructionBudgetDetail>();
+                List<ConstructionLedgerDetail> SumBuffer = new List<ConstructionLedgerDetail>();
+                //foreach (ConstructionBudgetDetail DetailRec in DetailList)
+                foreach (ConstructionLedgerDetail DetailRec in DetailList)
+                {
+                    // 1件目はバッファへセットして処理しない
+                    if (binit)
+                    {
+                        Break_CompanyCode = DetailRec.CompanyCode;
+                        Break_Total = DetailRec.ExecutionAmount;
+                        SumBuffer.Add(DetailRec);
+                        binit = false;
+                        continue;
+                    }
+                    // 会社コードが変わればデータセットへ行く
+                    if (Break_CompanyCode != DetailRec.CompanyCode)
+                    {
+                        // 協力業者発注合計が30万以上に注文書を発行する
+                        if (Break_Total >= CommonDefine.s_PrintOutPrice)
+                        {
+                            // ページ追加
+                            PurchaseOrderInputPage inputpage = new PurchaseOrderInputPage();
+                            CreateNewPage(ref inputpage, icnt, (int)CommonDefine.OrderSheetType.SimpleType);
+                            m_TabPageList.Add(inputpage);
+
+                            // グループ５コンボボックスセット
+                            SetInitcmbPersonInCharge(inputpage);
+
+                            // 注文書枝番セット
+                            inputpage.SeqNo = ++PageSeqNo;
+                            // データをセットする
+                            SetConstructionBudget(inputpage, SumBuffer, icnt);
+                            icnt++;
+                        }
+                        // バッファクリア
+                        SumBuffer.Clear();
+                        // ブレイクキーセット
+                        Break_CompanyCode = DetailRec.CompanyCode;
+                        // 協力業者発注合計をクリア
+                        Break_Total = 0;
+                    }
+                    // データ退避
+                    SumBuffer.Add(DetailRec);
+                    // 協力業者発注合計に金額を加算
+                    Break_Total += DetailRec.ExecutionAmount;
+                }
+
+                // 協力業者発注合計が30万以上に注文書を発行する
+                if (Break_Total >= CommonDefine.s_PrintOutPrice)
+                {
+                    // ページ追加
+                    PurchaseOrderInputPage inputpage = new PurchaseOrderInputPage();
+                    CreateNewPage(ref inputpage, icnt, (int)CommonDefine.OrderSheetType.SimpleType);
+                    m_TabPageList.Add(inputpage);
+
+                    // 注文書枝番セット
+                    inputpage.SeqNo = ++PageSeqNo;
+                    // データをセットする
+                    SetConstructionBudget(inputpage, SumBuffer, icnt);
+                    icnt++;
+                }
+                //// 支払条件の初期設定
+                //if (!GetConstructionTypeToExecNo())
+                //{
+                //    // 注文書種別(簡易版)
+                //    radioButton1.Checked = true;
+                //}
+                //else
+                //{
+                //    // 注文書種別(正規版)
+                //    radioButton2.Checked = true;
+                //}
+                EventArgs e = new EventArgs();
+                radioButton1_CheckedChanged((object)radioButton1, e);
+
+                return true;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                DetailDB.close(); DetailDB = null;
+                OrderDB.close(); OrderDB = null;
+            }
+        }
+        #endregion
+
+        #region 工事詳細台帳データより画面へデータをセットする
+        /// <summary>
+        /// 工事詳細台帳データより画面へデータをセットする
+        /// </summary>
+        /// <param name="inputpage"></param>
+        /// <param name="DetailRec"></param>
+        //private bool SetConstructionBudget(PurchaseOrderInputPage inputpage, List<ConstructionBudgetDetail> DetailList, int PageCount)
+        private bool SetConstructionBudget(PurchaseOrderInputPage inputpage, List<ConstructionLedgerDetail> DetailList, int PageCount)
+        {
+            try
+            {
+                // 協力会社コード
+                inputpage.OrderCompanyCode = DetailList[0].CompanyCode;
+                // 協力会社名セット
+                inputpage.EntryTab.Text = DetailList[0].CompanyName;
+                inputpage.PageValueItem[(int)PageValue.SubConstractorName].Text = DetailList[0].CompanyName;
+                // 発注番号セット
+                inputpage.PageValueItem[(int)PageValue.OrdersNo].Text = string.Format("{0}-{1}", m_ConstructionCode, (PageCount + 1).ToString("000"));
+
+                int Linecnt = 0;
+                double TotalPrice = 0;
+                DataGridView dgv = inputpage.Group1DataGridView;
+                //foreach (ConstructionBudgetDetail DetailRec in DetailList)
+                foreach (ConstructionLedgerDetail DetailRec in DetailList)
+                {
+                    // 15行以上は処理しない
+                    if (Linecnt > (dgv.RowCount - 1)) break;
+                    DataGridViewRow CurRow = dgv.Rows[Linecnt];
+                    // 番号
+                    CurRow.Cells[(int)DispDetailGridColumn.No].Value = (Linecnt + 1);
+                    // グループ番号
+                    CurRow.Cells[(int)DispDetailGridColumn.GroupNo].Value = DetailRec.GroupCount;
+                    // 構成コード
+                    CurRow.Cells[(int)DispDetailGridColumn.ComponentCode].Value = DetailRec.ComponentCode;
+                    // 工種コード
+                    CurRow.Cells[(int)DispDetailGridColumn.ItemCode].Value = DetailRec.ItemCode;
+                    // 項目・品名
+                    CurRow.Cells[(int)DispDetailGridColumn.FirstName].Value = DetailRec.FirstString;
+                    // 内容内訳
+                    CurRow.Cells[(int)DispDetailGridColumn.SecondName].Value = DetailRec.SecondString;
+                    // 数量
+                    CurRow.Cells[(int)DispDetailGridColumn.Quantity].Value = 1;
+                    // 単位
+                    CurRow.Cells[(int)DispDetailGridColumn.UnitName].Value = "式";
+                    // 金額
+                    CurRow.Cells[(int)DispDetailGridColumn.PriceValue].Value = DetailRec.ExecutionAmount.ToString("#,0");
+                    // 元工事番号
+                    CurRow.Cells[(int)DispDetailGridColumn.SourceCode].Value = DetailRec.ConstructionCode;
+                    TotalPrice += DetailRec.ExecutionAmount;
+                    Linecnt++;
+
+                }
+
+                // 支払条件の初期設定
+                if (!GetConstructionTypeToExecNo())
+                {
+                    // 簡易版支払い条件セット
+                    InitGroupBox2(inputpage);
+                }
+                else
+                {
+                    InitGroupBox3(inputpage);
+                }
+
+                // 発注金額
+                inputpage.PageValueItem[(int)PageValue.OrderPrice].Text = TotalPrice.ToString("#,0");
+                // グリッド合計表示
+                inputpage.Group1Label.Text = inputpage.PageValueItem[(int)PageValue.OrderPrice].Text;
+                // 発注書作成日
+                inputpage.PageTextBox.Text = DateTime.Now.ToShortDateString();
+
+
+                return true;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+        // ---------- 工事詳細台帳よりデータ作成　　　　↑↑
+
+        // ---------- 注文書よりデータ作成          　↓↓
         #region 注文書データを取得
         /// <summary>
         /// 注文書データを取得して画面表示する
@@ -265,8 +696,17 @@
             try
             {
                 // 注文書データ読込
-                string strSQL = OrderDB.CreatePrimarykeyString(m_ConstructionCode);
-                strSQL += " ORDER BY SEQNO";
+                string strSQL = " WHERE";
+                bool bFirst = true;
+                foreach (object[] objRec in m_DetailList)
+                {
+                    if (!bFirst) strSQL += " Or";
+                    strSQL += string.Format(" (CONSTRUCTIONCODE = {0}", CommonMotions.cnvInt(objRec[(int)FrmOrderEntryList.ReadDBColumn.SourceCode]));
+                    strSQL += string.Format(" AND SEQNO = {0})", CommonMotions.cnvInt(objRec[(int)FrmOrderEntryList.ReadDBColumn.PurchaseSeqNo]));
+                    bFirst = false;
+                }
+                strSQL += " ORDER BY CONSTRUCTIONCODE, SEQNO";
+
                 List<PurchaseOrder> OrderList = new List<PurchaseOrder>();
                 if (!OrderDB.SelectAction(strSQL, ref OrderList)) return false;
                 if (OrderList.Count == 0) return false;
@@ -289,7 +729,7 @@
 
                     // グループ５コンボボックスセット
                     SetInitcmbPersonInCharge(inputpage);
-                    
+
                     // ページデータをセットする
                     SetPurchaseOrderPage(ref inputpage, OrderRec, icnt);
                     // 明細データをセットする
@@ -307,7 +747,7 @@
             finally
             {
                 OrderDB.close(); OrderDB = null;
-                DetailDB.close(); DetailDB=null;
+                DetailDB.close(); DetailDB = null;
             }
         }
         #endregion
@@ -323,11 +763,12 @@
             try
             {
                 inputpage.OrderCompanyCode = DataRec.CompanyCode;                                   // 協力会社コード
+                inputpage.SeqNo = DataRec.SeqNo;
 
                 SubContractorMaster SubRec = new SubContractorMaster();
                 string strSQL = SubCDB.CreatePrimarykeyString(DataRec.CompanyCode);
                 SubCDB.SelectAction(strSQL, ref SubRec);
-                 
+
                 // 協力会社名セット
                 inputpage.EntryTab.Text = SubRec.CompanyName;
                 inputpage.PageValueItem[(int)PageValue.SubConstractorName].Text = SubRec.CompanyName;
@@ -371,7 +812,7 @@
                         inputpage.Group3TextBox[(int)Group3TextBox.PrePaymentsDays].Enabled = true;
                         inputpage.Group3TextBox[(int)Group3TextBox.PrePaymentsPrice].Enabled = true;
                     }
-                    if(DataRec.PartialPayment == 1)                     // 部分払
+                    if (DataRec.PartialPayment == 1)                     // 部分払
                     {
                         inputpage.Group3CheckBox[(int)Group3CheckBox.Partial].Checked = true;
                         inputpage.Group3TextBox[(int)Group3TextBox.PartialPaymentMounth].Text = DataRec.PartialPaymentMounth.ToString("0");     // 部分払締切月
@@ -384,7 +825,7 @@
                         inputpage.Group3TextBox[(int)Group3TextBox.PartialPaymentDay2].Enabled = true;
                         inputpage.Group3TextBox[(int)Group3TextBox.PartialPaymentPrice].Enabled = true;
                     }
-                    if(DataRec.CompletionPayment == 1)	                                            // 引渡し時の支払
+                    if (DataRec.CompletionPayment == 1)	                                            // 引渡し時の支払
                     {
                         inputpage.Group3CheckBox[(int)Group3CheckBox.Complete].Checked = true;
                         inputpage.Group3TextBox[(int)Group3TextBox.CompletionPaymentDays].Text = DataRec.CompletionPaymentDays.ToString("0");   // 引渡し時の支払日数
@@ -444,10 +885,11 @@
                     GetRow.Cells[(int)DispDetailGridColumn.UnitName].Value = DetailRec.UnitName;                                // 単位
                     GetRow.Cells[(int)DispDetailGridColumn.UnitPrice].Value = DetailRec.UnitPrice.ToString("#,#");	            // 単価
                     GetRow.Cells[(int)DispDetailGridColumn.PriceValue].Value = DetailRec.OrdersLinePrice.ToString("#,0");       // 金額
-                    
+                    GetRow.Cells[(int)DispDetailGridColumn.SourceCode].Value = DetailRec.SourceCode;                            // 元工事番号
+
                     // 金額集計
                     PriceValueValue += DetailRec.OrdersLinePrice;
-                    
+
                     iRow++;
                 }
                 // グリッド合計表示
@@ -455,7 +897,7 @@
 
                 // 条件グリッド
                 iRow = CommonDefine.Group4GridStaticString.Length;
-                
+
                 foreach (PurchaseOrderDetail DetailRec in DetailList)
                 {
                     DataGridViewRow GetRow = inputpage.Group4DataGridView.Rows[iRow];
